%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% commands

% |\pgfcdprset| allows keys that belong to pgf-cdpr to be easily set.
\newcommand\pgfcdprset[1]{\pgfset{/cdpr/.cd, #1}}%
% |\pgfcdprget| allows keys that belong to pgf-cdpr to be easily retrieved.
\newcommand\pgfcdprget[1]{\pgfkeysvalueof{/cdpr/#1}}%
% |\pgfcdprresetstyle| allows resetting a style within pgf-cdpr quite easily
\newcommand\pgfcdprresetstyle[1]{\pgfset{/cdpr/#1/.style={}}}%

%% END commands
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%





%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% additional tikz/pgf libraries to load                                      %%

\usepgflibrary{plotmarks}
\usepgflibrary{fpu}
\usetikzlibrary{3d}
\usetikzlibrary{colorbrewer}
\usetikzlibrary{arrows}
\usetikzlibrary{arrows.meta}
\usetikzlibrary{bending}
\usetikzlibrary{calc}
\usetikzlibrary{decorations.pathmorphing}
\usetikzlibrary{decorations.markings}
\usetikzlibrary{external}
\usetikzlibrary{fadings}
\usetikzlibrary{patterns}
\usetikzlibrary{pgfplots.statistics}
\usetikzlibrary{shapes.misc}
\usetikzlibrary{spy}
\usetikzlibrary{through}
\usetikzlibrary{angles}
\usetikzlibrary{arrows}
\usetikzlibrary{arrows.meta}
\usetikzlibrary{backgrounds}
\usetikzlibrary{calc}
\usetikzlibrary{decorations}
\usetikzlibrary{decorations.text}
\usetikzlibrary{decorations.markings}
\usetikzlibrary{fit}
\usetikzlibrary{intersections}
\usetikzlibrary{mindmap}
\usetikzlibrary{patterns}
\usetikzlibrary{pgfplots.groupplots}
\usetikzlibrary{plotmarks}
\usetikzlibrary{positioning}
\usetikzlibrary{quotes}
\usetikzlibrary{shadows}
\usetikzlibrary{shapes}
\usetikzlibrary{spy}
\usetikzlibrary{trees}

\pgfplotsset{compat=newest}

%% END additional tikz/pgf libraries to load                                  %%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%





%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% setup

\pgfkeys{%
  % This namespace is a family of namespaces
  /cdpr/.is family,%
  % Fall back to searching inside /pgf/
  /cdpr/.belongs to family=/tikz,%
  % Forward anything unknown to the '/pgf' namespace
  /cdpr/.unknown/.forward to=/tikz,%
}%

% Set an initially empty style for "remaining keys"
\pgfcdprresetstyle{remaining keys}%

\newlength\pgf@cdpr@markersize
\pgfcdprset{%
  % Code to execute when setting marker size
  marker size/.code={%
    \setlength{\pgf@cdpr@markersize}{#1}%
  },%
  % Default marker size for automatically marked lines
  marker size=0.33ex,%
  % Default number of markers for automatically marked lines
  marker count/.initial=5,%
  %
  % Code to execute when highlighting color is set
  highlight color/.initial=yellow,%
  % Remaining keys not matching in this namespace
  remaining keys/.style={},%
  % collect unknown keys in style '/cdpr/remaining keys':
  .unknown/.code={%
    \let\currname\pgfkeyscurrentname%
    \let\currval\pgfkeyscurrentvalue%
    \ifx#1\pgfkeysnovalue%
      \pgfqkeys{/cdpr}{%
        remaining keys/.append style/.expand once={\currname}%
      }%
    \else%
      \pgfqkeys{/cdpr}{%
        remaining keys/.append style/.expand twice={\expandafter\currname\expandafter=\currval}%
      }%
    \fi%
  }%
}%

%% END setup
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%





%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% node styles
\pgfcdprset{%
  % No margin inside
  no margin/.style={%
    inner sep=0.00em,%
  },%
  % A very tight node inside
  very tight margin/.style={%
    inner sep=0.083325em,%
  },%
  % A tight node inside
  tight margin/.style={%
    inner sep=0.16665em,%
  },%
  % Normal node inside
  normal margin/.style={%
    inner sep=0.3333em,%
  },%
  % Loose node inside
  loose margin/.style={%
    inner sep=0.6666em,%
  },%
  % Very loose node inside
  very loose margin/.style={%
    inner sep=1.3332em,%
  },%
  % No padding outside
  no padding/.style={%
    outer sep=0.00em,%
  },%
  % A very tight node outside
  very tight padding/.style={%
    outer sep=0.083325em,%
  },%
  % A tight node outside
  tight padding/.style={%
    outer sep=0.16665em,%
  },%
  % A normal node outside
  normal padding/.style={%
    outer sep=0.3333em,%
  },%
  % A loose node outside
  loose padding/.style={%
    outer sep=0.6666em,%
  },%
  % A very loose node outside
  very loose padding/.style={%
    outer sep=1.3332em,%
  },%
  % A boxed node
  boxed/.style={%
    draw,%
  },%
  highlighted/.style={%
    color=\pgfcdprget{highlight color},%
  },%
}
%% END node styles
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%





%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% styles for mechanical pieces

\pgfcdprset{%
  % Color definitions
  cable color/.initial=Red,%
  cable axis color/.initial=FireBrick,%
  rigid body draw color/.initial=PrimaryColor,%
  rigid body fill color/.initial=PrimaryColorLight,%
  %
  % Floor or ground or surface
  floor/.style={
    draw=PrimaryColor,%
    fill=PrimaryColorVeryLight,%
  },%
  % A pulley style
  pulley/.style={
    shape=circle,%
    minimum width=2em,%
    transform shape,%
    draw=PrimaryColor,%
    fill=PrimaryColorVeryLight!50,%
  },%
  % The cable
  cable/.style={%
    color=\pgfcdprget{cable color},%
  },%
  cable axis/.style={%
    color=\pgfcdprget{cable axis color},%
  },%
  rigid body/.style={%
    draw=\pgfcdprget{rigid body draw color},%
    fill=\pgfcdprget{rigid body fill color},%
  },%
}

%% END styles for mechanical pieces
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%





%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% euclidean drawing

\pgfcdprset{%
}

%% END euclidean drawing
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
